/* -*- Mode: C++; tab-width: 20; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is websupergoo.com code.
 *
 * The Initial Developer of the Original Code is Finn International.
 * Portions created by the Initial Developer are Copyright (C) 2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Chris Yuen <chris@websupergoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include "K2CrystalService.h"

#include "nsCOMPtr.h"
#include "nsServiceManagerUtils.h"

NS_IMPL_ISUPPORTS1(K2CrystalService, K2ICrystalService)

K2CrystalService::K2CrystalService() : mCallback(nsnull) { }
K2CrystalService::~K2CrystalService() { }

/* attribute K2ICrystalService callback; */
NS_IMETHODIMP K2CrystalService::GetCallback(K2ICrystalCallback * *aCallback)
{
	NS_ENSURE_ARG_POINTER(aCallback);
	*aCallback = mCallback;
	NS_IF_ADDREF(*aCallback);
    return NS_OK;
}

NS_IMETHODIMP K2CrystalService::SetCallback(K2ICrystalCallback * aCallback)
{
	mCallback = aCallback;
    return NS_OK;
}

/* void addStatic (in nsIAtom obj, in short key); */
NS_IMETHODIMP K2CrystalService::AddStatic(nsIAtom *obj, PRInt16 key)
{
	if(mAssocs.find(key) != mAssocs.end())
	{
		NS_ASSERTION(mAssocs[key] == obj, "Attempt to overwrite an existing static");
		return NS_OK;
	}

	PRBool rv = mStatics.AppendObject(obj);
	mAssocs.insert(std::make_pair(key, obj));

	return rv ? NS_OK : NS_ERROR_UNEXPECTED;
}

/* nsIAtom getStatic (in short key); */
NS_IMETHODIMP K2CrystalService::GetStatic(PRInt16 key, nsIAtom **_retval NS_OUTPARAM)
{
	NS_ENSURE_ARG_POINTER(_retval);

	if(mAssocs.find(key) == mAssocs.end())
	{
		*_retval = nsnull;
		return NS_ERROR_FAILURE;
	}

	*_retval = mAssocs[key];
    return NS_OK;
}

already_AddRefed<K2ICrystalCallback> GetCurrentCrystalCallback()
{
    nsresult rv;

	nsCOMPtr<K2ICrystalService> crystal =
		do_GetService(K2_CRYSTALSERVICE_CONTRACTID, &rv);
	if(NS_FAILED(rv)) return nsnull;

	nsCOMPtr<K2ICrystalCallback> ret;
	rv = crystal->GetCallback(getter_AddRefs(ret));
	if(NS_FAILED(rv))
		return nsnull;

	return ret.forget();
}
